<form (ngSubmit)="onSubmit()" [formGroup]="form">
  <ng-container *ngFor="let field of DATA let i = index">

    <ng-container [formGroupName]="field.group" *ngIf="field.group == displayFormGroup">

      <div [ngSwitch]="field.type" class="mb-3">

        <label *ngSwitchCase="'text'" [htmlFor]="field.name">{{ field.label }}</label>
        <input class="form-control" *ngSwitchCase="'text'" [formControlName]="field.name"
               [id]="field.name" [type]="field.type">

        <label *ngSwitchCase="'select'" [htmlFor]="field.name">{{ field.label }}</label>
        <select class="form-control" [id]="field.name" *ngSwitchCase="'select'" [formControlName]="field.name">
          <option *ngFor="let opt of field?.options" [value]="opt.value">{{opt.text}}</option>
        </select>

        <label *ngSwitchCase="'toggle'" [htmlFor]="field.name">{{ field.label }}</label>
        <div *ngSwitchCase="'toggle'" class="switch">
          <input type="checkbox" name="switch" [id]="field.name" [formControlName]="field.name">
          <label [for]="field.name"></label>
        </div>

        <label *ngSwitchCase="'checkbox'" [htmlFor]="field.name">{{ field.label }}</label>
        <input *ngSwitchCase="'checkbox'" type="checkbox" [formControlName]="field.name" [id]="field.name">

      </div>

      <div class="errorMessage" *ngIf="isInValid[field.group].get(field.name)?.invalid && isInValid[field.group].get(field.name)?.touched">

        <div *ngIf="isInValid[field.group].get(field.name)?.getError('required')">
          {{field.label}} is required
        </div>

        <div *ngIf="isInValid[field.group].get(field.name)?.getError('minlength') || isInValid[field.group].get(field.name)?.getError('maxlength')">
          First name must be greater than 3 character and less than 9 characters
        </div>

      </div>

    </ng-container>
  </ng-container>


  <div class="form-btn" *ngIf="displayFormGroup">
    <button type="submit" [disabled]="">Show result</button>
    <button type="button" (click)="form.reset()">Clear</button>
  </div>
</form>

<h3>Press F1 to run the submit form</h3>
<h3>Press F2 to run the reset form</h3>

<pre class="code" *ngIf="payLoad">
  {{payLoad}}
</pre>
